/**
 *  出勤表 逻辑
 */

import moment = require("moment");
import { getWorkLogListByTime } from "../data/admin/workinglog";

export async function getAttendanceData(year:number, month:number) {
    
    let startTime = moment(`${year}-${month}-1 00:00:00`).format("YYYY-MM-DD HH:mm:SS");
    let endTime = moment(`${year}-${month}-1 00:00:00`).add(1, 'months').format("YYYY-MM-DD HH:mm:SS");

    let workLog = await getWorkLogListByTime(startTime, endTime);

    //获取日历标题
    let tileList = [{label:"姓名", prop:"name", index:0}];
    let dataCount = moment(startTime).daysInMonth();
    for (let i = 1; i <= dataCount; i++) {
        let dateKey = moment(`${year}-${month}-${i} 00:00:00`).format("MM-DD");
        tileList.push({label:dateKey, prop:dateKey, index:i});
        // let weekDays = moment(dateKey).day();
        // if (weekDays == 0 || weekDays == 6) {
        //     jumpMap[dateKey] = "-";
        // } else {

        // }
    }

    let dataMap = {};
    workLog.forEach(info => {
        let {dateKey, name, time} = info;
        let key = moment(dateKey).format("MM-DD");
        if (!dataMap[name]) dataMap[name] = {name};
        if (!dataMap[name][key] )  dataMap[name][key] = 0;
        dataMap[name][key] += time;
    }) 

    let dataList = Object.values(dataMap);

    return {dataList, tileList};
}