import moment = require("moment");
import { ERRORENUM } from "../config/errorEnum";
import { addProject, findAllProject, findOnceProjectById, updateProject } from "../data/admin/project"
import { BizError } from "../util/bizError";



export async function projectListForSelect() {
    
    let projectList = await findAllProject();

    return {dataList:projectList}
}

export async function allProjectList() {
    let projectList = await findAllProject();
   
    let dataList = [];
    projectList.forEach(info => {
        dataList.push({
            id:info.id,
            name:info.name,
            controller:info.controller||"",
            controllerStr:info.controller || "无",
            createTime:info.createTime ? new Date(info.createTime).valueOf() : 0
        });
    });
    dataList.sort( (a, b) => { return new Date(b.createTime  || 0).valueOf() - new Date(a.createTime  || 0).valueOf() });

    return {dataList};
}

export async function addProjectData(id:string, name:string, controller:string) {
    let projectInfo = await findOnceProjectById(id);
    if (projectInfo.id) throw new BizError(ERRORENUM.项目ID已存在);

    await addProject(id, name, controller, moment().format("YYYY-MM-DD HH:mm:ss") );

    return {isSuccess:true, message:"添加成功"};
}

export async function updateProjectData(id:string, name:string, controller:string) {
    let projectInfo = await findOnceProjectById(id);
    if (!projectInfo.id) throw new BizError(ERRORENUM.目标数据已不存在);

    await updateProject(id, name, controller );

    return {isSuccess:true, message:"修改成功"};
}