const Sequelize = require('sequelize');

export async function instantiateModel(tableName:string, config) {
    let tablesBase = {};
    for ( let key in config) {
        let info = config[key];
        let keysValue:any = {type:null};

        if (typeof config.type.isFinite == "function") {
            keysValue.type = Sequelize.INTEGER;
        } else if (typeof config.type.concat == "function") {
            keysValue.type = Sequelize.STRING(200);
        } else if (typeof config.type.getFullYear == "function") {
            keysValue.type = Sequelize.DATE;
        }
        if (info.mainKey) {
            keysValue.primaryKey = true;  //表示主键
            keysValue.allowNull = false;   //表示当前列是否允许为空，false表示该列不能为空
            keysValue.unique = true;   //表示该列的值必须唯一
        }
        if (info.allowNull) {
            keysValue.allowNull = info.allowNull;
        }
        tablesBase[key] = keysValue;
    }
    let defaultConfig = {
        freezeTableName:true,
        timestamps:false,
    }

    let model = Sequelize.mysqlDB.define(tableName, tablesBase, defaultConfig);

    return await model.sysc({});
}
